searchData={"items":[{"type":"module","title":"LiveViewNative.LiveForm","doc":"","ref":"LiveViewNative.LiveForm.html"},{"type":"module","title":"LiveViewNative.LiveForm.Component","doc":"Base components for LiveForm","ref":"LiveViewNative.LiveForm.Component.html"},{"type":"function","title":"LiveViewNative.LiveForm.Component.async_result/1","doc":"Please see the documentation for Phoenix.Component.async_result/1","ref":"LiveViewNative.LiveForm.Component.html#async_result/1"},{"type":"function","title":"Attributes - LiveViewNative.LiveForm.Component.async_result/1","doc":"* `assign` (`Phoenix.LiveView.AsyncResult`) (required)","ref":"LiveViewNative.LiveForm.Component.html#async_result/1-attributes"},{"type":"function","title":"Slots - LiveViewNative.LiveForm.Component.async_result/1","doc":"* `loading` - rendered while the assign is loading for the first time.\n* `failed` - rendered when an error or exit is caught or assign_async returns `{:error, reason}` for the first time. Receives the error as a `:let`.\n* `inner_block` - rendered when the assign is loaded successfully via `AsyncResult.ok/2`. Receives the result as a `:let`.","ref":"LiveViewNative.LiveForm.Component.html#async_result/1-slots"},{"type":"function","title":"LiveViewNative.LiveForm.Component.form/1","doc":"Renders a form.\n\nThis form component behaves identital to `Phoenix.Component.form/1`. Please\nrefer to that docmentation for usage details. on arguments. This component\nis platform agnostic. The ` ` element will be implemented in all\nsupported clients. Third-party clients can also implement their own ` `\nelement and take advantage of this component.","ref":"LiveViewNative.LiveForm.Component.html#form/1"},{"type":"function","title":"Attributes - LiveViewNative.LiveForm.Component.form/1","doc":"* `for` (`:any`) (required) - An existing form or the form source data.\n* `action` (`:string`) - The action to submit the form on.\n  This attribute must be given if you intend to submit the form to a URL without LiveView.\n\n* `as` (`:atom`) - The prefix to be used in names and IDs generated by the form.\n  For example, setting `as: :user_params` means the parameters\n  will be nested \"user_params\" in your `handle_event` or\n  `conn.params[\"user_params\"]` for regular HTTP requests.\n  If you set this option, you must capture the form with `:let`.\n\n* `csrf_token` (`:any`) - A token to authenticate the validity of requests.\n  One is automatically generated when an action is given and the method is not `get`.\n  When set to `false`, no token is generated.\n\n* `errors` (`:list`) - Use this to manually pass a keyword list of errors to the form.\n  This option is useful when a regular map is given as the form\n  source and it will make the errors available under `f.errors`.\n  If you set this option, you must capture the form with `:let`.\n\n* `method` (`:string`) - The HTTP method.\n  It is only used if an `:action` is given. If the method is not `get` nor `post`,\n  an input tag with name `_method` is generated alongside the form tag.\n  If an `:action` is given with no method, the method will default to `post`.\n\n* `multipart` (`:boolean`) - Sets `enctype` to `multipart/form-data`.\n  Required when uploading files.\n\n  Defaults to `false`.\n* Global attributes are accepted. Additional HTML attributes to add to the form tag. Supports all globals plus: `[\"autocomplete\", \"name\", \"rel\", \"enctype\", \"novalidate\", \"target\"]`.","ref":"LiveViewNative.LiveForm.Component.html#form/1-attributes"},{"type":"function","title":"Slots - LiveViewNative.LiveForm.Component.form/1","doc":"* `inner_block` (required) - The content rendered inside of the form tag.","ref":"LiveViewNative.LiveForm.Component.html#form/1-slots"},{"type":"function","title":"LiveViewNative.LiveForm.Component.inputs_for/1","doc":"Renders nested form inputs for associations or embeds.","ref":"LiveViewNative.LiveForm.Component.html#inputs_for/1"},{"type":"function","title":"Attributes - LiveViewNative.LiveForm.Component.inputs_for/1","doc":"* `field` (`Phoenix.HTML.FormField`) (required) - A %Phoenix.HTML.Form{}/field name tuple, for example: {@form[:email]}.\n* `id` (`:string`) - The id to be used in the form, defaults to the concatenation of the given\n  field to the parent form id.\n\n* `as` (`:atom`) - The name to be used in the form, defaults to the concatenation of the given\n  field to the parent form name.\n\n* `default` (`:any`) - The value to use if none is available.\n* `prepend` (`:list`) - The values to prepend when rendering. This only applies if the field value\n  is a list and no parameters were sent through the form.\n\n* `append` (`:list`) - The values to append when rendering. This only applies if the field value\n  is a list and no parameters were sent through the form.\n\n* `skip_hidden` (`:boolean`) - Skip the automatic rendering of hidden fields to allow for more tight control\n  over the generated markup.\n\n  Defaults to `false`.\n* `options` (`:list`) - Any additional options for the `Phoenix.HTML.FormData` protocol\n  implementation.\n\n  Defaults to `[]`.","ref":"LiveViewNative.LiveForm.Component.html#inputs_for/1-attributes"},{"type":"function","title":"Slots - LiveViewNative.LiveForm.Component.inputs_for/1","doc":"* `inner_block` (required) - The content rendered for each nested form.","ref":"LiveViewNative.LiveForm.Component.html#inputs_for/1-slots"},{"type":"function","title":"Examples - LiveViewNative.LiveForm.Component.inputs_for/1","doc":"```heex\n<.form\n  :let={f}\n  phx-change=\"change_name\"\n>\n  <.inputs_for :let={f_nested} field={f[:nested]}>\n    <.input type=\"text\" field={f_nested[:name]} />\n  </.inputs_for>\n</.form>\n```","ref":"LiveViewNative.LiveForm.Component.html#inputs_for/1-examples"},{"type":"function","title":"Dynamically adding and removing inputs - LiveViewNative.LiveForm.Component.inputs_for/1","doc":"Dynamically adding and removing inputs is supported by rendering named buttons for\ninserts and removals. Like inputs, buttons with name/value pairs are serialized with\nform data on change and submit events. Libraries such as Ecto, or custom param\nfiltering can then inspect the parameters and handle the added or removed fields.\nThis can be combined with `Ecto.Changeset.cast/3`'s `:sort_param` and `:drop_param`\noptions. For example, imagine a parent with an `:emails` `has_many` or `embeds_many`\nassociation. To cast the user input from a nested form, one simply needs to configure\nthe options:\n\n    schema \"mailing_lists\" do\n      field :title, :string\n\n      embeds_many :emails, EmailNotification, on_replace: :delete do\n        field :email, :string\n        field :name, :string\n      end\n    end\n\n    def changeset(list, attrs) do\n      list\n      |> cast(attrs, [:title])\n      |> cast_embed(:emails,\n        with: &email_changeset/2,\n        sort_param: :emails_sort,\n        drop_param: :emails_drop\n      )\n    end\n\nHere we see the `:sort_param` and `:drop_param` options in action.\n\n> Note: `on_replace: :delete` on the `has_many` and `embeds_many` is required\n> when using these options.\n\nWhen Ecto sees the specified sort or drop parameter from the form, it will sort\nthe children based on the order they appear in the form, add new children it hasn't\nseen, or drop children if the parameter instructs it to do so.\n\nThe markup for such a schema and association would look like this in SwiftUI:\n\n```heex\n<.inputs_for :let={ef} field={@form[:emails]}>\n   \n  <.input type=\"text\" field={ef[:email]} placeholder=\"email\" />\n  <.input type=\"text\" field={ef[:name]} placeholder=\"name\" />\n   \n    <.icon name=\"hero-x-mark\" class=\"w-6 h-6 relative top-2\" />\n   \n</.inputs_for>\n\n \n\n \n  add more\n \n```\n\nWe used `inputs_for` to render inputs for the `:emails` association, which\ncontains an email address and name input for each child. Within the nested inputs,\nwe render a hidden `mailing_list[emails_sort][]` input, which is set to the index of the\ngiven child. This tells Ecto's cast operation how to sort existing children, or\nwhere to insert new children. Next, we render the email and name inputs as usual.\nThen we render a button containing the \"delete\" text with the name `mailing_list[emails_drop][]`,\ncontaining the index of the child as its value.\n\nLike before, this tells Ecto to delete the child at this index when the button is\nclicked. We use `phx-click={Native.dispatch(\"change\")}` on the button to tell LiveView\nto treat this button click as a change event, rather than a submit event on the form,\nwhich invokes our form's `phx-change` binding.\n\nOutside the `inputs_for`, we render an empty `mailing_list[emails_drop][]` input,\nto ensure that all children are deleted when saving a form where the user\ndropped all entries. This hidden input is required whenever dropping associations.\n\nFinally, we also render another button with the sort param name `mailing_list[emails_sort][]`\nand `value=\"new\"` name with accompanied \"add more\" text. Please note that this button must\nhave `type=\"button\"` to prevent it from submitting the form.\nEcto will treat unknown sort params as new children and build a new child.\nThis button is optional and only necessary if you want to dyamically add entries.\nYou can optionally add a similar button before the `<.inputs_for>`, in the case you want\nto prepend entries.","ref":"LiveViewNative.LiveForm.Component.html#inputs_for/1-dynamically-adding-and-removing-inputs"},{"type":"function","title":"LiveViewNative.LiveForm.Component.to_form/2","doc":"","ref":"LiveViewNative.LiveForm.Component.html#to_form/2"},{"type":"function","title":"LiveViewNative.LiveForm.Component.used_input?/1","doc":"Checks if the input field was used by the client.\n\nThis function conforms exactly the same as `Phoenix.Component.used_input?/1`","ref":"LiveViewNative.LiveForm.Component.html#used_input?/1"},{"type":"extras","title":"LiveForm for LiveView Native","doc":"# LiveForm for LiveView Native\n\n`liveview-native-live-form` is an add-on library for [LiveView Native](https://github.com/liveview-native/live_view_native). It adds support for HTML-style forms on native platforms.","ref":"readme.html"},{"type":"extras","title":"Installation - LiveForm for LiveView Native","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Elixir - LiveForm for LiveView Native","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `live_view_native_live_form` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:live_view_native_live_form, \"~> 0.4.0-rc.0\"}\n  ]\nend\n```","ref":"readme.html#elixir"},{"type":"extras","title":"SwiftUI - LiveForm for LiveView Native","doc":"1. In Xcode, select *File → Add Packages...*\n2. Enter the package URL `https://github.com/liveview-native/liveview-native-live-form`\n3. Select *Add Package*","ref":"readme.html#swiftui"},{"type":"extras","title":"Usage - LiveForm for LiveView Native","doc":"Import `LiveViewNativeLiveForm` and add `.liveForm` to the list of addons on your `LiveView`:\n\n```swift\nimport SwiftUI\nimport LiveViewNative\nimport LiveViewNativeLiveForm\n\nstruct ContentView: View {\n    var body: some View {\n        #LiveView(\n            .localhost,\n            addons: [.liveForm]\n        )\n    }\n}\n```\n\nNow you can use the `LiveForm` and `LiveSubmitButton` elements in your template.\n\n```heex\n \n   Username \n   Password \n   Submit \n \n```","ref":"readme.html#usage"}],"content_type":"text/markdown","proglang":"elixir","producer":{"name":"ex_doc","version":"0.36.1"}}